unit Unit1;

// Latest update: 22-08-2010

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    Timer1: TTimer;
    ComboBox1: TComboBox;
    Button2: TButton;
    Button3: TButton;
    RadioGroup1: TRadioGroup;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Timer2: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    function DoReceive: longint;
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses RcsTiming, WinCom;

var ComPort: byte;
  PerfTimer1: TPerformanceTimer;
  SendCaret : boolean;

var ReceiveBuffer: array[0..64000] of ansichar; //

procedure TForm1.FormShow(Sender: TObject); // startup
begin
  ComPort := 0; // no open comport
  ComboBox1.ItemIndex := -1;
  SendCaret := false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction); // exit
begin
  CloseCom(ComPort);
end;

procedure TForm1.Button1Click(Sender: TObject); // send
var Nr: longint;
begin
  Nr := 0;
  if ComIsOpen(ComPort) then Nr := SendString(ComPort, Edit1.Text {+ #13 + #10});
  Edit2.Text := IntToStr(Nr);
end;

procedure TForm1.ComboBox1Change(Sender: TObject); // change open comport
begin
  if ComboBox1.ItemIndex <> (ComPort - 1) then
  begin
    CloseCom(ComPort);
    ComPort := ComboBox1.ItemIndex + 1;
    OpenCom(ComPort, BaudRate_115K, Parity_none, 8, Stopbits_1, 64000, 64000);
    Button1.Enabled := true;
    Button4.Enabled := true;
    Button5.Enabled := true;
    Button6.Enabled := true;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject); // clear the reception memo
begin
  Memo1.Lines.Clear;
end;

function TForm1.DoReceive: longint; // receive chars and display them in the memo
var I: longint;
  Str: ansistring;
begin
  Result := 0;
  if ComIsOpen(ComPort) then
  begin
    Result := ReceiveChars(ComPort, ReceiveBuffer, SizeOf(ReceiveBuffer));
    if Result > 0 then
    begin
        Memo1.Lines.Add('# BytesReceived: ' + IntToStr(Result));
        Str := '';
        for I := 0 to Result - 1 do if ReceiveBuffer[I] > #0 then Str := Str + ReceiveBuffer[I];
        Memo1.Lines.Add(Str);
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject); // receive manually
begin
  DoReceive;
end;

procedure TForm1.Timer1Timer(Sender: TObject); // timer based reception
begin
  DoReceive;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var Buf: array[0..1] of ansichar;
begin
  Buf[0] := '^';
  if Sendcaret and ComIsOpen(ComPort) then SendChars(ComPort, Buf, 1);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject); // change reception mode (manually or timer)
begin
  case RadioGroup1.ItemIndex of
    -1: ;
    0: begin // manual reception
        Timer1.Enabled := false;
        Button3.Enabled := true;
      end;
    1: begin // timer reception
        Timer1.Enabled := true;
        Button3.Enabled := false;
      end;
  end; {case}
end;

procedure TForm1.Button4Click(Sender: TObject);
var Block, I: word;
    SendBuf: array[0..4095] of ansichar;
    Recvd: byte;
    TimeElapsed, SendSpeed: real;
    Str: ansistring;
begin
  Screen.Cursor := crHourGlass;
  Timer1.Enabled := false;
  Timer2.Enabled := false;
  Application.ProcessMessages;

  for I := 0 to SizeOf(SendBuf) - 1 do SendBuf[I] := '_';

  FlushReceiveBuffer(ComPort);
  FlushSendBuffer(ComPort);

  // signal a receive operation for the PIC
  SendBuf[0] := '%';
  SendChars(ComPort, SendBuf, 1);

  Sleep(100);

  PerfTimer1.Reset;
  PerfTimer1.Start;
  // send 256 kb data
  for Block := 0 to 63 do SendChars(ComPort, SendBuf, SizeOf(SendBuf));
  PerfTimer1.Stop;

  TimeElapsed := PerfTimer1.Value;
  SendSpeed := (64 * 4096) / TimeElapsed / 1024;
  Str := FloatToStrF(SendSpeed, ffFixed, 7, 2);
  Str := 'Speed PC -> PIC (KB/s): ' + Str;

  repeat
    ReceiveBuffer[0] := ' ';
    Recvd := NrCharsReceived(Comport);
    if Recvd > 0 then ReceiveChars(ComPort, ReceiveBuffer, SizeOf(ReceiveBuffer));
  until ReceiveBuffer[0] = '*';

  Memo1.Lines.Add(Str);

  if RadioGroup1.ItemIndex = 1 then Timer1.Enabled := true;
  Timer2.Enabled := Sendcaret;
  Screen.Cursor := crDefault;

end;

procedure TForm1.Button5Click(Sender: TObject);
var TotReceived: Dword;
  Recvd: DWord;
  SendElapsed, SendSpeed: real;
  Str: ansistring;
begin
  Screen.Cursor := crHourGlass;
  Timer1.Enabled := false;
  Timer2.Enabled := false;
  Application.ProcessMessages;

 // Receivetest 256 Kb (= 262144 bytes);
  TotReceived := 0;

  FlushReceiveBuffer(ComPort);
  FlushSendBuffer(ComPort);

 // signal the PIC to send
  SendString(Comport, '*'); // dump 265 Kb

  PerfTimer1.Reset;
  PerfTimer1.Start;

 // get PIC data
  repeat
    if NrCharsReceived(Comport) > 0 then
    begin
      Recvd := ReceiveChars(ComPort, ReceiveBuffer, SizeOf(ReceiveBuffer));
      TotReceived := TotReceived + Recvd;
    end;
  until (TotReceived = 262144);

  PerfTimer1.Stop;

  SendElapsed := PerfTimer1.Value;
  SendSpeed := TotReceived / SendElapsed / 1024;
  Str := FloatToStrF(SendSpeed, ffFixed, 7, 2);
  Str := 'Speed PIC -> PC (KB/s): ' + Str;
  Memo1.Lines.Add(Str);

  if RadioGroup1.ItemIndex = 1 then Timer1.Enabled := true;
  Timer2.Enabled := Sendcaret;
  Screen.Cursor := crDefault;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  SendCaret := not Sendcaret;
  Timer2.Enabled := Sendcaret;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 {Enter} then Button1Click(Sender);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PerfTimer1 := TPerformanceTimer.Create('SendTime');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  PerfTimer1.Free;
end;

end.
